<template>
  <q-page class="text-left-wrap">
    <div class="q-pa-md">
      <h2>{{ this.question }}</h2>
      <strong>
        {{ this.description }}
      </strong>
    </div>
    <div class="q-ml-md">
      <q-option-group v-model="group" :options="options" color="primary" />
    </div>
    <div>
      <q-btn
        class="q-ma-md"
        color="black"
        text-color="white"
        label="Submit"
        @click="submitVote"
      />
    </div>
  </q-page>
</template>

<script>
import { api } from "boot/axios";
import { mapGetters } from "vuex";

export default {
  name: "PageIndex",
  data() {
    return {
      question: "",
      description: "",
      group: "1",
      options: []
    };
  },
  methods: {
    async getData() {
      const url = window.location.pathname;
      const token = url.substring(url.lastIndexOf("/") + 1);
      console.log(token);
      await api
        .post("/api/poll/getPoll", { polltkn: token })
        .then(res => {
          this.question = res.data.question;
          this.description = res.data.description;
          for (let i = 0; i < res.data.options.length; i++) {
            let tmp = {
              label: res.data.options[i].text,
              value: res.data.options[i].option_no
            };

            this.options.push(tmp);
          }
          this.group = this.options[0].value;
        })
        .catch(error => {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: error.message
          });
        });
    },

    async submitVote() {
      const url = window.location.pathname;
      const token = url.substring(url.lastIndexOf("/") + 1);

      const reqData = {
        polltkn: token,
        option: this.group,
        token: sessionStorage.token
      };

      await api
        .post("/api/user/vote", reqData)
        .then(res => {
          if (res.status == 201 || res.status == 203) {
            this.$router.push({ path: "/onsubmit" });
          } else {
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: res.error
            });
          }
        })
        .catch(error => {
          if (error.response.status == 404)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Poll not found"
            });

          if (error.response.status == 403)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "You don't have access to this poll"
            });

          if (error.response.status == 423)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Voting is no longer accepted in this poll"
            });

          if (error.response.status == 500)
            this.$q.notify({
              color: "red-5",
              textColor: "white",
              icon: "warning",
              message: "Server error"
            });
        });
    }
  },
  created() {
    this.getData();
    //call methods
  },
  computed: {
    ...mapGetters("user", ["username", "department", "position", "hireDate"])
  }
};
</script>
